<template>
  <div class="terminal-window">
    <div
      class="terminal-container"
      ref="term"
    ></div>
  </div>
</template>

<script>
import "xterm/dist/xterm.css";
import { Terminal } from "xterm";
import * as fit from "xterm/lib/addons/fit/fit";
import * as attach from "xterm/lib/addons/attach/attach";

Terminal.applyAddon(fit);
Terminal.applyAddon(attach);

export default {
  data() {
    return {
      ws: "",
      term: "",
      termTheme: {
        foreground: "#ffffff",
        background: "rgba(27, 33, 47, 0)",
        cursor: "#007acc",
        selection: "rgba(255, 255, 255, 0.3)",
        black: "#000000",
        brightBlack: "#808080",
        red: "#ce2f2b",
        brightRed: "#f44a47",
        green: "#00b976",
        brightGreen: "#05d289",
        yellow: "#e0d500",
        brightYellow: "#f4f628",
        magenta: "#bd37bc",
        brightMagenta: "#d86cd8",
        blue: "#1d6fca",
        brightBlue: "#358bed",
        cyan: "#00a8cf",
        brightCyan: "#19b8dd",
        white: "#e5e5e5",
        brightWhite: "#ffffff"
      },
      termSetting: {
        fontSize: 12,
        fontFamily: "liga source code pro, source code pro, consolas, monospace, courier-new, courier",
        fontWeight: "normal",
        fontWeightBold: "bold",
        allowTransparency: true,
        enableBold: true,
        cursorBlink: true,
        rendererType: "canvas"
      }
    };
  },
  methods: {
    termInit() {
      const term = this.termOpen(this.$refs.term);
      const ws = this.wsCreate();
      this.term = term;
      this.ws = ws;
      this.termResizeListener(term, ws);
      this.wsHandle(term, ws);
    },
    termOpen(target) {
      let setting = this.termSetting;
      setting.theme = this.termTheme;
      const term = new Terminal(setting);
      term.open(target);
      return term;
    },
    termResizeListener(term, ws) {
      term.on("resize", size => {
        let resize = JSON.stringify({
          channel: 'gateway_service',
          method: 'msgSend',
          params: {
            sendTo: 'xterm_server',
            msg: {
              option: 'term_resize',
              data: {
                cols: size.cols,
                rows: size.rows
              }
            }
          }
        });

        WebSocket.prototype.send.call(ws, resize);
      });
    },
    wsCreate() {
      const domain = process.env.VUE_APP_WS_HOST;
      const ws = new WebSocket(`ws://${domain}`);
      ws.onerror = () => {};

      return ws;
    },
    async wsHandle(term, ws, reconnect = false) {
      ws.onclose = () => {
        this.wsReconnect(term);
      };

      await new Promise(resolve => {
        ws.onopen = () => {
          ws.send(JSON.stringify({
            channel: 'gateway_service',
            method: 'clientRegister',
            params: {
              uuid: 'xterm_client',
            }
          }));

          ws.send(JSON.stringify({
            channel: 'gateway_service',
            method: 'msgSend',
            params: {
              sendTo: 'xterm_server',
              msg: {
                option: 'term_init'
              }
            }
          }));

          ws.send = function(data) {
            WebSocket.prototype.send.call(
              this,
              JSON.stringify({
                channel: 'gateway_service',
                method: 'msgSend',
                params: {
                  sendTo: 'xterm_server',
                  msg: {
                    option: 'term_cmd',
                    data
                  }
                }
              })
            );
          };

          ws.binaryType = "arraybuffer";
          if (reconnect) term.write("\r\n");
          term.attach(ws, true, true);
          resolve();
        };
      });
      term.fit();
    },
    wsReconnect(term) {
      setTimeout(() => {
        const ws = this.wsCreate();
        this.wsHandle(term, ws, true);
      }, 2000);
    },
    resize() {
      this.term.fit();
    },
    registFocus() {
      this.$refs.term.addEventListener(
        'click',
        () => this.term.focus(),
        true
      );
    }
  },
  mounted() {
    this.termInit();
    this.registFocus();
  }
};
</script>

<style>
.terminal-window {
  position: relative;
  margin: 0 auto;
  height: 100%;
  width: 100%;
  background-color: hsla(222, 27%, 15%, .9);
}
.terminal-container {
  height: 100%;
  width: 100%;
}
.terminal-container .xterm .xterm-screen {
  margin-left: 8px;
}
.terminal-container .xterm .xterm-screen:hover {
  cursor: text;
}
.terminal-container .xterm .xterm-viewport {
  overflow-y: auto;
}
.terminal-container .xterm .xterm-viewport::-webkit-scrollbar {
  width: 6px;
}
.terminal-container .xterm .xterm-viewport::-webkit-scrollbar-track {
  background: hsl(222, 27%, 15%);
  border-radius: 6px;
}
.terminal-container .xterm .xterm-viewport::-webkit-scrollbar-thumb {
  background: hsl(204, 100%, 40%);
  border-radius: 10px;
}
.terminal-container .xterm .xterm-viewport::-webkit-scrollbar-thumb:hover {
  background: hsl(204, 100%, 32%);
}
</style>
